﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net;
using System.Web;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.ServiceModel.Web;
using System.IO;
using System.Globalization;

namespace SendToNWCConsole
{
    public class NWCCaller
    {
        public String BaseToken { get; set; }
        public String BaseURL { get; set; }
        public String Token { get; set; }
        public List<string> ListFileTokens { get; set; }
        public String Response { get; set; }

        public NWCCaller(String _baseUrl, String _baseToken)
        {
            BaseToken = _baseToken;
            BaseURL = _baseUrl;
            Token = "";
            ListFileTokens = new List<string>();
            Response = "";
        }

        public async Task StartNWCWorkflow(String _sInstanceToken, List<String> _fileTokens)
        {
            HttpWebRequest webrequest = (HttpWebRequest)WebRequest.Create(BaseURL + "?token=" + BaseToken);
            webrequest.Method = "POST";
            webrequest.ContentType = "application/json";
            //webrequest.Headers.Add("Username", "xyz");

            String sFileTokens = "[\"" + _fileTokens[0] + "\"]";

            String sBody = "{" +
                              "\"startData\": {" +
                                "\"se_file_data\": " + sFileTokens + "," +
                                "\"se_name\": \"Wombat\"" +
                              "}," +
                              "\"options\": {" +
                                "\"instanceToken\": \"" + _sInstanceToken + "\"" +
                              "}" +
                           "}";

            Console.WriteLine(sBody);

            using (var sr = new StreamWriter(webrequest.GetRequestStreamAsync().Result))
            {
                sr.Write(sBody);
            }

            WebResponse webresponse = webrequest.GetResponseAsync().Result;
            Encoding enc = System.Text.Encoding.GetEncoding("utf-8");
            string result = string.Empty;
            using (var resp = new StreamReader(webresponse.GetResponseStream(), enc))
            {
                result = resp.ReadToEnd();
            }
            Response = result;
        }

        public async Task GetTokenFromNWC()
        {
            using (var client = new HttpClient())
            {
                using (var response = client.PostAsync(BaseURL + "/create?token=" + BaseToken, null).Result)
                {
                    String sResponse = response.Content.ReadAsStringAsync().Result;
                    Token = sResponse;
                }
            }
        }

        public async Task SendFilesToNWC(string _sInstanceToken, IEnumerable<FileInfo> _files)
        {
            using (var client = new HttpClient())
            {
                client.DefaultRequestHeaders.TransferEncoding.Add(new System.Net.Http.Headers.TransferCodingHeaderValue("chunked"));
                client.DefaultRequestHeaders.TransferEncodingChunked = true;
                foreach (var file in _files)
                {
                    using (var content = new MultipartFormDataContent("Upload----" + DateTime.Now.ToString(CultureInfo.InvariantCulture)))
                    {
                        content.Add(new StringContent(_sInstanceToken), "Instance-Token");
                        content.Add(new StringContent(file.Name), "File-Name");
                        content.Add(new StreamContent(new FileStream(file.FullName, FileMode.Open, FileAccess.Read)), "File", file.Name);

                        using (var response = client.PostAsync(BaseURL + "/uploads?token=" + BaseToken, content).Result)
                        {
                            String sResponse = response.Content.ReadAsStringAsync().Result;
                            ListFileTokens.Add(sResponse);
                        }
                    }
                }
            }
        }

    }
}
